﻿namespace Bmp.Core.Lite.Metadata;

public class MetaDataWrap
{
    public IReadOnlyDictionary<string, string>? RawTags { get; init; }
    public TimeSpan Duration { get; init; }

    public string? Title => RawTags?.TryGetValue("TITLE", out var text) == true ? text : null;
    public string? Artist => RawTags?.TryGetValue("ARTIST", out var text) == true ? text : null;
    public string? Album => RawTags?.TryGetValue("ALBUM", out var text) == true ? text : null;

    //TODO: MetaData TrackNo track xx/yy
    public int? TrackNo => RawTags?.TryGetValue("track", out var num) == true ? int.TryParse(num, out var track) ? track : null : null;

}