﻿using Bmp.Core.Lite.Playback.Outputs.NAudioASIO;

namespace Bmp.Core.Lite.Playback.Outputs;

public class AsioOutput : IOutputDeviceInfo
{
    public string Id => ToString();
    public override string ToString() => DisplayName;
    public string DisplayName => $"{Type}: {DriverName}";

    internal AsioOutput(string driverName) => DriverName = driverName;
    public string DriverName { get; }

    public OutputType Type => OutputType.ASIO;

    public bool CanSetLatency => false;
    public bool HasControlPanel => true;

    public void ShowControlPanel()
    {
        var asioDriverExt = new AsioDriverExt(DriverName);
        asioDriverExt.ShowControlPanel();
        asioDriverExt.ReleaseDriver();
    }

    public int Latency { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }
}