﻿namespace Bmp.Core.Lite.Playback.Outputs.BASS_ASIO;

/// <summary>
/// BassAsio Future values that might be used with the <see cref="M:Un4seen.BassAsio.BassAsio.ASIO_Future(System.Int32,System.IntPtr)" /> method.
/// <para>Note: Other/Additional values might be possible - see your drivers manual for details.</para>
/// </summary>
public enum ASIOFuture
{
    /// <summary>No arguments</summary>
    EnableTimeCodeRead = 1,
    /// <summary>No arguments</summary>
    DisableTimeCodeRead = 2,
    /// <summary>ASIOInputMonitor* in params</summary>
    SetInputMonitor = 3,
    /// <summary>ASIOTransportParameters* in params</summary>
    Transport = 4,
    /// <summary>ASIOChannelControls* in params, apply gain</summary>
    SetInputGain = 5,
    /// <summary>ASIOChannelControls* in params, fill meter</summary>
    GetInputMeter = 6,
    /// <summary>ASIOChannelControls* in params, apply gain</summary>
    SetOutputGain = 7,
    /// <summary>ASIOChannelControls* in params, fill meter</summary>
    GetOutputMeter = 8,
    /// <summary>No arguments</summary>
    CanInputMonitor = 9,
    /// <summary>No arguments</summary>
    CanTimeInfo = 10, // 0x0000000A
    /// <summary>No arguments</summary>
    CanTimeCode = 11, // 0x0000000B
    /// <summary>No arguments</summary>
    CanTransport = 12, // 0x0000000C
    /// <summary>No arguments</summary>
    CanInputGain = 13, // 0x0000000D
    /// <summary>No arguments</summary>
    CanInputMeter = 14, // 0x0000000E
    /// <summary>No arguments</summary>
    CanOutputGain = 15, // 0x0000000F
    /// <summary>No arguments</summary>
    CanOutputMeter = 16, // 0x00000010
    /// <summary>DSD support: ASIOIoFormat * in params</summary>
    SetIoFormat = 588323169, // 0x23111961
    /// <summary>DSD support: ASIOIoFormat * in params</summary>
    GetIoFormat = 588323203, // 0x23111983
    /// <summary>DSD support: ASIOIoFormat * in params</summary>
    CanDoIoFormat = 588324868, // 0x23112004
}