﻿using System.Runtime.InteropServices;

namespace Bmp.Core.Lite.Playback.Outputs.BASS_ASIO
{
    /// <summary>
    /// Used with <see cref="M:Un4seen.BassAsio.BassAsio.BASS_ASIO_Future(System.Int32,System.IntPtr)" /> and the DSD IoFormat selector.
    /// </summary>
    [Serializable]
    [StructLayout(LayoutKind.Sequential)]
    public unsafe class ASIOIoFormat
    {
        const int cb = 512 - 8;

        public ASIOIoFormat()
        {
            future = Marshal.AllocHGlobal(cb);
        }

        ~ASIOIoFormat()
        {
            Marshal.FreeHGlobal(future);
        }

        public string MysteriousField => Marshal.PtrToStringUTF8(future, cb);

        /// <summary>
        /// One of the following format values:
        /// <para>
        /// <list type="table">
        /// <item><term>FormatInvalid</term><description>-1</description></item>
        /// <item><term>PCMFormat </term><description>0</description></item>
        /// <item><term>DSDFormat </term><description>1</description></item>
        /// </list>
        /// </para>
        /// </summary>
        public int formatType = -1;

        /// <summary>up to 508 chars</summary>
        public nint future;
    }
}
