﻿using NAudio.Wave;

namespace Bmp.Core.Lite.Playback.Outputs;

public class DirectSoundOutput : IOutputDeviceInfo
{
    public string Id => $"{Type}: {DeviceInfo.Guid}";
    public override string ToString() => $"{Type}: {DeviceInfo.Description} ({DeviceInfo.Guid})";
    public string DisplayName => $"{Type}: {DeviceInfo.Description}";

    public DirectSoundDeviceInfo DeviceInfo { get; }

    public DirectSoundOutput(DirectSoundDeviceInfo deviceInfo) => DeviceInfo = deviceInfo;

    public OutputType Type => OutputType.DirectSound;

    public bool HasControlPanel => false;

    public void ShowControlPanel() => throw new NotSupportedException();

    public bool CanSetLatency => true;
    public int Latency { get; set; } = 40;
}
