﻿using System;
using System.Runtime.InteropServices;
using System.Threading;
using Bmp.Core.Lite.Playback.Outputs.NAudioASIO;

namespace Bmp.Poc.PoCs;

internal static class PocAsioDSDStart
{
    public static void MainFunc()
    {
        var asioDriverName = "Creative SB USB DSD ASIO Device";

        var drv = new AsioDriverExt(asioDriverName);
        drv.Future_SetIoFormat_DSD();
        var sampleRate = 2822400;

        var flagDSD1 = drv.Future_GetIoFormat_Is_DSD();
        if (flagDSD1)
        {
            var flag = drv.IsSampleRateSupported(sampleRate);
            if (flag) drv.SetSampleRate(sampleRate, false);
        }

        var channels = 2;
        var nbSamples = drv.CreateBuffers(channels, 0, false);
        var bufSize = (int)(nbSamples * channels * 1.0 / 8);
        var buf = new byte[bufSize];

        var rng = new Random();
        drv.FillBufferCallback = (inputChannels, outputChannels) =>
        {
            for (int i = 0; i < channels; i++)
            {
                rng.NextBytes(buf);
                Marshal.Copy(buf, 0, outputChannels[i], bufSize);
            }

        };

        drv.Start();
        while (true)
        {
            Thread.Sleep(3000);
        }
    }

}