﻿// See https://aka.ms/new-console-template for more information

using System;
using System.Threading;
using Bmp.Core.Common.Net;
using Bmp.Core.Lite.Playback.MiddleWare;
using Bmp.Core.Playback.Inputs;
using NAudio.Wave;
using AsioOut = Bmp.Core.Lite.Playback.Outputs.NAudioASIO.AsioOut;
using static Bmp.Poc.Const;

namespace Bmp.Poc.PoCs;

internal class PocAsioFFMpegHttpSeekingPlayback
{
    public static void MainFunc()
    {
        var asioDriverName = "Creative SB USB RT ASIO Device";

        var shs = new SeekableHttpStream(UrlFlac24Bit96Khz);
        var source = new FFMPEGAudioStream(shs);
        //var source = new NAudioFFMPEGAudioReader(UrlFlac24Bit96Khz);

        var sourceBitPerRawSample = source.BitPerRawSample;

        var vdWrap = new VisualizeDataMiddleWare(source);
        var vdSourceBitPerRawSample = source.BitPerRawSample;


        var driverNames = AsioOut.GetDriverNames();
        var driverIndex = Array.IndexOf(driverNames, asioDriverName);

        var outputDevice = new AsioOut(driverIndex);

        vdWrap.DataTransferred += (_, args) =>
        {
            Console.WriteLine($"{DateTime.Now:HH:mm:ss.ff} {nameof(vdWrap.DataTransferred)}:{args.Bytes.Length}");
        };

        outputDevice.Init(vdWrap);

        outputDevice.Play();

        while (outputDevice.PlaybackState == PlaybackState.Playing)
        {
            Console.WriteLine($"{source.CurrentTime}/{source.TotalTime}");
            Thread.Sleep(3000);
            outputDevice.Pause();
            source.CurrentTime = source.CurrentTime.Add(TimeSpan.FromSeconds(1));
            Thread.Sleep(100);
            outputDevice.Play();
        }
    }
}